2012-2013 ACM-ICPC, NEERC, Moscow Subregional Contest比赛题解

题目链接:2012-2013 ACM-ICPC, NEERC, Moscow Subregional Contest

集训队23.4.13训练

A. Ariel(暴力枚举,阅读理解)

思路

每次询问给出一个生物a,和一组特征,要求在这组特征中a有的其他生物也要有,a没有的其他生物也没有,问在符合条件的生物中,a排第几名。

把所有生物按特征组合分类到不同的vector里,这样有一共\(2^k = 1024\)种组合。

每次询问的时候遍历所有\(2^k\)个组合,在满足要求的组合中二分找到分数大于生物a的生物个数,全部加起来,就可以得到生物a的排名了。

吐槽

题意贼难读懂,阅读理解题。

代码

#include <bits/stdc++.h>
using namespace std;
using i64 = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    vector<vector<int>> st(1 << k);
    vector<int> sc(n), bit(n);
    for (int i = 0; i < n; i++) {
        int y;
        cin >> sc[i] >> y;
        int mask = 0;
        for (int j = 0; j < y; j++) {
            int f;
            cin >> f;
            f--;
            mask |= (1 << f);
        }
        bit[i] = mask;
        st[mask].push_back(sc[i]);
    }
    for (int i = 0; i < (1 << k); i++) {
        sort(st[i].begin(), st[i].end());
    }

    int m;
    cin >> m;
    while (m--) {
        int x, y;
        cin >> x >> y;
        x--;
        int mask = 0;
        for (int i = 0; i < y; i++) {
            int f;
            cin >> f;
            f--;
            mask |= (1 << f);
        }

        int ans = 0;
        for (int i = 0; i < (1 << k); i++) {
            if ((i & mask) == (bit[x] & mask)) {
                ans += st[i].end() - upper_bound(st[i].begin(), st[i].end(), sc[x]);
            }
        }
        cout << ans + 1 << '\n';
    }

    return 0;
}

C. Cinderella(贪心)

思路

答案为大于平均值的数的数量

代码

#include <bits/stdc++.h>
using namespace std;
using i64 = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> a(n);
    double tot = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        tot += a[i];
    }
    tot /= n;

    int cnt = 0;
    for (int i = 0; i < n; i++) {
        cnt += (a[i] > tot);
    }
    cout << cnt << '\n';

    return 0;
}

E. Epic Fail of a Genie(贪心)

思路

  1. 大于1的全选
  2. 小于0的两两相乘配对,大于1的话选
  3. 如果选完后发现是空集,则判断选两个最小的数还是一个最大的正数。
  4. 浮点数精度误差问题,可以*100把两位小数变为整数再比大小。

代码

#include <bits/stdc++.h>
using namespace std;
using i64 = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<pair<i64, int>> a;
    a.reserve(n);
    for (int i = 0; i < n; i++) {
        double x;
        cin >> x;
        a.emplace_back(x * 100, i);
    }

    sort(a.begin(), a.end());

    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (i % 2 && a[i].first < 0 && a[i - 1].first * a[i].first > 100 * 100) {
            ans.push_back(a[i - 1].second);
            ans.push_back(a[i].second);
        }
        if (a[i].first > 100) {
            ans.push_back(a[i].second);
        }
    }

    if (ans.empty()) {
        if (n == 1) {
            ans.push_back(0);
        } else if (a[0].first * a[1].first > a.back().first * 100) {
            ans.push_back(a[0].second);
            ans.push_back(a[1].second);
        } else {
            ans.push_back(a.back().second);
        }
    }

    sort(ans.begin(), ans.end());
    cout << ans.size() << '\n';
    for (auto x : ans) {
        cout << x + 1 << " \n"[x == ans.back()];
    }

    return 0;
}

F. Flood(bfs)

思路

bfs模拟一遍即可。

代码

#include <bits/stdc++.h>
using namespace std;
using i64 = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cout << fixed << setprecision(8);

    int n, k;
    cin >> n >> k;
    vector<double> had(n), cap(n);
    for (int i = 0; i < n; i++) {
        cin >> cap[i] >> had[i];
    }

    vector<vector<int>> adj(n);
    for (int i = 0; i < k; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        adj[u].push_back(v);
    }

    int X, Y, Z;
    cin >> X >> Y >> Z;
    X--, Z--;

    queue<int> q;
    q.push(X);
    had[X] += Y;
    while (!q.empty()) {
        int u = q.front();
        q.pop();

        if (had[u] > cap[u]) {
            if (adj[u].size() > 0) {
                double add = (had[u] - cap[u]) / adj[u].size();
                for (auto v : adj[u]) {
                    had[v] += add;
                    q.push(v);
                }
            }
            had[u] = cap[u];
        }
    }

    cout << had[Z] << '\n';

    return 0;
}

G. Gadget Hackwrench(lca)

思路

看作一棵树,正向边边权为1,反向边边权为-1。

对于询问的两点u,v,找到\(lca(u, v) = mid\);对于u和mid,\(d = dep[u] - dep[mid]\),d 必须等于u和mid之间的边权和,v和mid同理。且u到mid的边权都为-1, v到mid的边权都为1。

代码

#include <bits/stdc++.h>
using namespace std;
using i64 = long long;

struct Tree {
    vector<int> sz, top, dep, parent, in;
    int cur;
    vector<vector<int>> e;
    Tree(int n) : sz(n), top(n), dep(n), parent(n, -1), e(n), in(n), cur(0) {}
    void add(int u, int v) {
        e[u].push_back(v), e[v].push_back(u);
    }
    void init() {
        dfsSz(0), dfsHLD(0);
    }
    void dfsSz(int u) {
        if (parent[u] != -1) e[u].erase(find(e[u].begin(), e[u].end(), parent[u]));
        sz[u] = 1;
        for (int &v : e[u]) {
            parent[v] = u;
            dep[v] = dep[u] + 1;
            dfsSz(v);
            sz[u] += sz[v];
            if (sz[v] > sz[e[u][0]]) swap(v, e[u][0]);
        }
    }
    void dfsHLD(int u) {
        in[u] = cur++;
        for (int v : e[u]) {
            if (v == e[u][0]) {
                top[v] = top[u];
            } else {
                top[v] = v;
            }
            dfsHLD(v);
        }
    }
    int lca(int u, int v) {
        while (top[u] != top[v]) {
            if (dep[top[u]] > dep[top[v]]) {
                u = parent[top[u]];
            } else {
                v = parent[top[v]];
            }
        }
        if (dep[u] < dep[v]) {
            return u;
        } else {
            return v;
        }
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    Tree tr(n);

    vector<vector<pair<int, int>>> adj(n);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        tr.add(u, v);
        adj[u].emplace_back(v, 1);
        adj[v].emplace_back(u, -1);
    }

    tr.init();

    vector<int> dis(n);
    function<void(int, int)> dfs = [&](int u, int pa) {
        for (auto [v, w] : adj[u]) {
            if (v == pa) continue;
            dis[v] = dis[u] + w;
            dfs(v, u);
        }
    };
    dfs(0, -1);

    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;

        int mid = tr.lca(x, y);
        int xd = dis[x] - dis[mid], yd = dis[y] - dis[mid];
        if (abs(xd) != tr.dep[x] - tr.dep[mid] || abs(yd) != tr.dep[y] - tr.dep[mid] || xd > 0 || yd < 0) {
            cout << "No\n";
            continue;
        }
        cout << "Yes\n";
    }

    return 0;
}

I. Innovative Business(贪心)

思路

能填就填,填不下就用一块完整的切分为多块小的填,注意碎片数量要尽可能少。

代码

#include <bits/stdc++.h>
using namespace std;
using i64 = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    int a, b;
    cin >> a >> b;

    int ans = (n / a) * (m / b);
    int ami = n % a, bmi = m % b;
    int acnt, aneed, bcnt, bneed;
    if (ami != 0) {
        acnt = a / ami;
        aneed = m / b;
        ans += (aneed + acnt - 1) / acnt;
    }
    if (bmi != 0) {
        bcnt = b / bmi;
        bneed = n / a;
        ans += (bneed + bcnt - 1) / bcnt;
    }
    if (ami != 0 && bmi != 0) {
        if (aneed % acnt == 0 && bneed % bcnt == 0) ans++;
    }
    cout << ans << '\n';

    return 0;
}

J. Just Another Disney Problem(STL,排序,交互题)

思路

注意到n<=1000,询问次数<=10000,故使用nlogn复杂度的排序算法即可,这里使用stl库里的stable_sort(),修改比较函数使用。

代码

#include <bits/stdc++.h>
using namespace std;
using i64 = long long;

int query(int x, int y) {
    cout << "1 " << x << " " << y << endl;
    string s;
    cin >> s;
    if (s == "YES") return true;
    return false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> a(n);
    iota(a.begin(), a.end(), 1);

    stable_sort(a.begin(), a.end(), [&](int i, int j) {
        return query(i, j);
    });

    cout << "0";
    for (int i = 0; i < n; i++) {
        cout << " " << a[i];
    }
    cout << endl;

    return 0;
}

K. Key to Magica's diary(模拟,技巧)

思路

直接暴力模拟即可。

一个提高编程效率的技巧是使用stringstream,可以很方便地在空格之间读取单词。

代码

#include <bits/stdc++.h>
using namespace std;
using i64 = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cout << fixed << setprecision(8);

    int n;
    cin >> n;

    vector<string> s;
    string ttt;
    getline(cin, ttt);
    for (int i = 0; i < n; i++) {
        string t;
        getline(cin, t);
        for (auto &c : t) {
            if (isalpha(c)) {
                c = tolower(c);
            } else {
                c = ' ';
            }
        }
        stringstream ss;
        ss << t;
        while (ss >> t) {
            s.push_back(t);
        }
    }

    int k;
    cin >> k;
    set<string> st;
    for (int i = 0; i < k; i++) {
        string t;
        cin >> t;
        st.insert(t);
    }
    vector<string> t;
    for (auto ss : s) {
        if (!st.count(ss)) {
            t.push_back(ss);
        }
    }
    s = t;

    int tot = s.size();
    map<string, int> cnt1;
    map<pair<string, string>, int> cnt2;
    for (auto ss : s) {
        cnt1[ss]++;
    }
    for (int i = 1; i < tot; i++) {
        cnt2[{s[i - 1], s[i]}]++;
    }

    int q;
    cin >> q;
    while (q--) {
        string a, b;
        cin >> a >> b;

        double num = 1.0 * (cnt2[{a, b}] + (a != b ? cnt2[{b, a}] : 0)) / (tot - 1);
        double den = 1.0 * cnt1[a] / tot * cnt1[b] / tot;
        double ans = num / den;
        cout << ans << '\n';
    }

    return 0;
}
posted @ 2023-04-14 14:34  blockche  阅读(38)  评论(0编辑  收藏  举报